'use strict';

var Enum = require('./Enum.js');
var Utility = require('./Utility.js');

/**
 * @param {object[]} children
 * @param {function} callback
 * @return {string}
 */
function serialize (children, callback) {
	var output = '';

	for (var i = 0; i < children.length; i++)
		output += callback(children[i], i, children, callback) || '';

	return output
}

/**
 * @param {object} element
 * @param {number} index
 * @param {object[]} children
 * @param {function} callback
 * @return {string}
 */
function stringify (element, index, children, callback) {
	switch (element.type) {
		case Enum.LAYER: if (element.children.length) break
		case Enum.IMPORT: case Enum.NAMESPACE: case Enum.DECLARATION: return element.return = element.return || element.value
		case Enum.COMMENT: return ''
		case Enum.KEYFRAMES: return element.return = element.value + '{' + serialize(element.children, callback) + '}'
		case Enum.RULESET: if (!Utility.strlen(element.value = element.props.join(','))) return ''
	}

	return Utility.strlen(children = serialize(element.children, callback)) ? element.return = element.value + '{' + children + '}' : ''
}

exports.serialize = serialize;
exports.stringify = stringify;
